diff --git a/rsvg-base.c b/rsvg-base.c
index d6b1f23..b0b7feb 100644
--- a/rsvg-base.c
+++ b/rsvg-base.c
@@ -915,33 +931,40 @@ rsvg_processing_instruction (void *ctx, const xmlChar * target, const xmlChar *
         char **xml_atts;
 
         xml_atts = rsvg_css_parse_xml_attribute_string ((const char *) data);
-        atts = rsvg_property_bag_new ((const char **) xml_atts);
 
-        if (atts) {
+        if (xml_atts) {
             const char *value;
 
+            atts = rsvg_property_bag_new ((const char **) xml_atts);
             value = rsvg_property_bag_lookup (atts, "alternate");
-            if (!value || (strcmp (value, "no") != 0)) {
+            if (!value || !value[0] || (strcmp (value, "no") != 0)) {
                 value = rsvg_property_bag_lookup (atts, "type");
                 if (value && strcmp (value, "text/css") == 0) {
                     value = rsvg_property_bag_lookup (atts, "href");
-                    if (value) {
-                        GByteArray *style;
-
-                        style =
-                            _rsvg_acquire_xlink_href_resource (value,
-                                                               rsvg_handle_get_base_uri (handle),
-                                                               NULL);
-                        if (style) {
-                            rsvg_parse_cssbuffer (handle, (char *) style->data, style->len);
-                            g_byte_array_free (style, TRUE);
+                    if (value && value[0]) {
+                        char *style_data;
+                        gsize style_data_len;
+                        char *mime_type = NULL;
+
+                        style_data = _rsvg_handle_acquire_data (handle,
+                                                                value,
+                                                                &mime_type,
+                                                                &style_data_len,
+                                                                NULL);
+                        if (style_data && 
+                            mime_type &&
+                            strcmp (mime_type, "text/css") == 0) {
+                            rsvg_parse_cssbuffer (handle, style_data, style_data_len);
                         }
+
+                        g_free (mime_type);
+                        g_free (style_data);
                     }
                 }
             }
 
-            g_strfreev (xml_atts);
             rsvg_property_bag_free (atts);
+            g_strfreev (xml_atts);
         }
     }
 }
@@ -954,12 +977,10 @@ rsvg_SAX_handler_struct_init (void)
 
         memset (&rsvgSAXHandlerStruct, 0, sizeof (rsvgSAXHandlerStruct));
 
-#ifdef RSVG_ENABLE_ENTITIES
         rsvgSAXHandlerStruct.getEntity = rsvg_get_entity;
         rsvgSAXHandlerStruct.entityDecl = rsvg_entity_decl;
         rsvgSAXHandlerStruct.unparsedEntityDecl = rsvg_unparsed_entity_decl;
         rsvgSAXHandlerStruct.getParameterEntity = rsvg_get_parameter_entity;
-#endif
         rsvgSAXHandlerStruct.characters = rsvg_characters;
         rsvgSAXHandlerStruct.error = rsvg_error_cb;
         rsvgSAXHandlerStruct.cdataBlock = rsvg_characters;
@@ -977,26 +998,27 @@ rsvg_path_is_uri (char const *path)
     char const *p;
 
     if (path == NULL)
-	return FALSE;
+        return FALSE;
 
     if (strlen (path) < 4)
-	return FALSE;
+        return FALSE;
 
-    if (   (path[0] < 'a' || path[0] > 'z')
-	&& (path[0] < 'A' || path[0] > 'Z'))
-	return FALSE;
+    if ((path[0] < 'a' || path[0] > 'z') &&
+        (path[0] < 'A' || path[0] > 'Z')) {
+        return FALSE;
+    }
 
     for (p = &path[1];
-	    (*p >= 'a' && *p <= 'z') 
-	 || (*p >= 'A' && *p <= 'Z') 
-	 || (*p >= '0' && *p <= '9') 
-	 || *p == '+' 
-	 || *p == '-' 
-	 || *p == '.';
-	 p++);
+	    (*p >= 'a' && *p <= 'z') ||
+        (*p >= 'A' && *p <= 'Z') ||
+        (*p >= '0' && *p <= '9') ||
+         *p == '+' ||
+         *p == '-' ||
+         *p == '.';
+        p++);
 
     if (strlen (p) < 3)
-	return FALSE;
+        return FALSE;
 
     return (p[0] == ':' && p[1] == '/' && p[2] == '/');
 }
@@ -1022,7 +1044,7 @@ rsvg_get_base_uri_from_filename (const gchar * filename)
 }
 
 /**
- * rsvg_handle_set_base_uri
+ * rsvg_handle_set_base_uri:
  * @handle: A #RsvgHandle
  * @base_uri: The base uri
  *
@@ -1035,6 +1057,7 @@ void
 rsvg_handle_set_base_uri (RsvgHandle * handle, const char *base_uri)
 {
     gchar *uri;
+    GFile *file;
 
     g_return_if_fail (handle != NULL);
 
@@ -1042,16 +1065,45 @@ rsvg_handle_set_base_uri (RsvgHandle * handle, const char *base_uri)
 	return;
 
     if (rsvg_path_is_uri (base_uri)) 
-	uri = g_strdup (base_uri);
+        uri = g_strdup (base_uri);
     else
-	uri = rsvg_get_base_uri_from_filename (base_uri);
+        uri = rsvg_get_base_uri_from_filename (base_uri);
 
-    if (uri) {
-        if (handle->priv->base_uri)
-            g_free (handle->priv->base_uri);
-        handle->priv->base_uri = uri;
-        rsvg_defs_set_base_uri (handle->priv->defs, handle->priv->base_uri);
-    }
+    file = g_file_new_for_uri (uri ? uri : "data:");
+    rsvg_handle_set_base_gfile (handle, file);
+    g_object_unref (file);
+    g_free (uri);
+}
+
+/**
+ * rsvg_handle_set_base_gfile:
+ * @handle: a #RsvgHandle
+ * @base_file: a #GFile
+ *
+ * Set the base URI for @handle from @file.
+ * Note: This function may only be called before rsvg_handle_write()
+ * or rsvg_handle_read_stream_sync() has been called.
+ *
+ * Since: 2.32
+ */
+void
+rsvg_handle_set_base_gfile (RsvgHandle *handle,
+                            GFile      *base_file)
+{
+    RsvgHandlePrivate *priv;
+
+    g_return_if_fail (RSVG_IS_HANDLE (handle));
+    g_return_if_fail (G_IS_FILE (base_file));
+
+    priv = handle->priv;
+
+    g_object_ref (base_file);
+    if (priv->base_gfile)
+        g_object_unref (priv->base_gfile);
+    priv->base_gfile = base_file;
+
+    g_free (priv->base_uri);
+    priv->base_uri = g_file_get_uri (base_file);
 }
 
 /**
@@ -1061,9 +1113,9 @@ rsvg_handle_set_base_uri (RsvgHandle * handle, const char *base_uri)
  * Gets the base uri for this #RsvgHandle.
  *
  * Returns: the base uri, possibly null
- * Since: 2.9 (really present in 2.8 as well)
+ * Since: 2.8
  */
-G_CONST_RETURN char *
+const char *
 rsvg_handle_get_base_uri (RsvgHandle * handle)
 {
     g_return_val_if_fail (handle, NULL);
@@ -1071,7 +1123,7 @@ rsvg_handle_get_base_uri (RsvgHandle * handle)
 }
 
 /**
- * rsvg_error_quark
+ * rsvg_error_quark:
  *
  * The error domain for RSVG
  *
@@ -1088,39 +1140,46 @@ rsvg_error_quark (void)
 static void
 rsvg_set_error (GError **error, xmlParserCtxtPtr ctxt)
 {
-  xmlErrorPtr xerr;
+    xmlErrorPtr xerr;
 
-  xerr = xmlCtxtGetLastError (ctxt);
-  if (xerr) {
-    g_set_error (error, rsvg_error_quark (), 0,
-                 _("Error domain %d code %d on line %d column %d of %s: %s"),
-                 xerr->domain, xerr->code,
-                 xerr->line, xerr->int2,
-                 xerr->file ? xerr->file : "data",
-                 xerr->message ? xerr->message: "-");
-  } else {
-    g_set_error (error, rsvg_error_quark (), 0, _("Error parsing XML data"));
-  }
+    xerr = xmlCtxtGetLastError (ctxt);
+    if (xerr) {
+        g_set_error (error, rsvg_error_quark (), 0,
+                     _("Error domain %d code %d on line %d column %d of %s: %s"),
+                     xerr->domain, xerr->code,
+                     xerr->line, xerr->int2,
+                     xerr->file ? xerr->file : "data",
+                     xerr->message ? xerr->message: "-");
+    } else {
+        g_set_error (error, rsvg_error_quark (), 0, _("Error parsing XML data"));
+    }
 }
 
-static gboolean
-rsvg_handle_write_impl (RsvgHandle * handle, const guchar * buf, gsize count, GError ** error)
+static void
+create_xml_push_parser_ctxt (RsvgHandle *handle)
 {
-    GError *real_error = NULL;
-    int result;
-
-    rsvg_return_val_if_fail (handle != NULL, FALSE, error);
-
-    handle->priv->error = &real_error;
     if (handle->priv->ctxt == NULL) {
         handle->priv->ctxt = xmlCreatePushParserCtxt (&rsvgSAXHandlerStruct, handle, NULL, 0,
                                                       rsvg_handle_get_base_uri (handle));
+        _rsvg_set_xml_parse_options(handle->priv->ctxt, handle);
 
         /* if false, external entities work, but internal ones don't. if true, internal entities
            work, but external ones don't. favor internal entities, in order to not cause a
            regression */
         handle->priv->ctxt->replaceEntities = TRUE;
     }
+}
+
+static gboolean
+rsvg_handle_write_impl (RsvgHandle * handle, const guchar * buf, gsize count, GError ** error)
+{
+    GError *real_error = NULL;
+    int result;
+
+    rsvg_return_val_if_fail (handle != NULL, FALSE, error);
+
+    handle->priv->error = &real_error;
+    create_xml_push_parser_ctxt (handle);
 
     result = xmlParseChunk (handle->priv->ctxt, (char *) buf, count, 0);
     if (result != 0) {
@@ -1148,22 +1207,23 @@ rsvg_handle_close_impl (RsvgHandle * handle, GError ** error)
     handle->priv->error = &real_error;
 
     if (handle->priv->ctxt != NULL) {
-        xmlDocPtr xmlDoc;
+        xmlDocPtr xml_doc;
         int result;
 
-        xmlDoc = handle->priv->ctxt->myDoc;
+        xml_doc = handle->priv->ctxt->myDoc;
 
         result = xmlParseChunk (handle->priv->ctxt, "", 0, TRUE);
-        xmlFreeParserCtxt (handle->priv->ctxt);
-        xmlFreeDoc (xmlDoc);
-
         if (result != 0) {
             rsvg_set_error (error, handle->priv->ctxt);
+            xmlFreeParserCtxt (handle->priv->ctxt);
+            xmlFreeDoc (xml_doc);
             return FALSE;
         }
+
+        xmlFreeParserCtxt (handle->priv->ctxt);
+        xmlFreeDoc (xml_doc);
     }
 
-    rsvg_defs_resolve_all (handle->priv->defs);
     handle->priv->finished = TRUE;
     handle->priv->error = NULL;
 
@@ -1175,29 +1235,19 @@ rsvg_handle_close_impl (RsvgHandle * handle, GError ** error)
     return TRUE;
 }
 
-static void
-rsvg_state_free_func (gpointer data, gpointer user_data)
-{
-    rsvg_state_finalize ((RsvgState *) data);
-    g_slice_free (RsvgState, data);
-}
-
 void
 rsvg_drawing_ctx_free (RsvgDrawingCtx * handle)
 {
     rsvg_render_free (handle->render);
 
-    g_slist_foreach (handle->state, rsvg_state_free_func, (gpointer) handle);
-    g_slist_free (handle->state);
+    rsvg_state_free_all (handle->state);
 
 	/* the drawsub stack's nodes are owned by the ->defs */
 	g_slist_free (handle->drawsub_stack);
 
-    g_slist_free (handle->ptrs);
+    g_warn_if_fail (handle->acquired_nodes == NULL);
+    g_slist_free (handle->acquired_nodes);
 	
-    if (handle->base_uri)
-        g_free (handle->base_uri);
-
     if (handle->pango_context != NULL)
         g_object_unref (handle->pango_context);
 
@@ -1209,13 +1259,15 @@ rsvg_drawing_ctx_free (RsvgDrawingCtx * handle)
  * @handle: An #RsvgHandle
  *
  * Returns the SVG's metadata in UTF-8 or %NULL. You must make a copy
- * of this metadata if you wish to use it after #handle has been freed.
+ * of this metadata if you wish to use it after @handle has been freed.
  *
- * Returns: The SVG's title
+ * Returns: (nullable): The SVG's title
  *
  * Since: 2.9
+ *
+ * Deprecated: 2.36
  */
-G_CONST_RETURN char *
+const char *
 rsvg_handle_get_metadata (RsvgHandle * handle)
 {
     g_return_val_if_fail (handle, NULL);
@@ -1231,13 +1283,15 @@ rsvg_handle_get_metadata (RsvgHandle * handle)
  * @handle: An #RsvgHandle
  *
  * Returns the SVG's title in UTF-8 or %NULL. You must make a copy
- * of this title if you wish to use it after #handle has been freed.
+ * of this title if you wish to use it after @handle has been freed.
  *
- * Returns: The SVG's title
+ * Returns: (nullable): The SVG's title
  *
  * Since: 2.4
+ *
+ * Deprecated: 2.36
  */
-G_CONST_RETURN char *
+const char *
 rsvg_handle_get_title (RsvgHandle * handle)
 {
     g_return_val_if_fail (handle, NULL);
@@ -1253,13 +1307,15 @@ rsvg_handle_get_title (RsvgHandle * handle)
  * @handle: An #RsvgHandle
  *
  * Returns the SVG's description in UTF-8 or %NULL. You must make a copy
- * of this description if you wish to use it after #handle has been freed.
+ * of this description if you wish to use it after @handle has been freed.
  *
- * Returns: The SVG's description
+ * Returns: (nullable): The SVG's description
  *
  * Since: 2.4
+ *
+ * Deprecated: 2.36
  */
-G_CONST_RETURN char *
+const char *
 rsvg_handle_get_desc (RsvgHandle * handle)
 {
     g_return_val_if_fail (handle, NULL);
@@ -1271,9 +1327,9 @@ rsvg_handle_get_desc (RsvgHandle * handle)
 }
 
 /**
- * rsvg_handle_get_dimensions
+ * rsvg_handle_get_dimensions:
  * @handle: A #RsvgHandle
- * @dimension_data: A place to store the SVG's size
+ * @dimension_data: (out): A place to store the SVG's size
  *
  * Get the SVG's size. Do not call from within the size_func callback, because an infinite loop will occur.
  *
@@ -1286,23 +1342,24 @@ rsvg_handle_get_dimensions (RsvgHandle * handle, RsvgDimensionData * dimension_d
      * To prevent an infinite loop we are saving the state.
      */
     if (!handle->priv->in_loop) {
-	handle->priv->in_loop = TRUE;
-	rsvg_handle_get_dimensions_sub (handle, dimension_data, NULL);
-	handle->priv->in_loop = FALSE;
+        handle->priv->in_loop = TRUE;
+        rsvg_handle_get_dimensions_sub (handle, dimension_data, NULL);
+        handle->priv->in_loop = FALSE;
     } else {
-	/* Called within the size function, so return a standard size */
-	dimension_data->em = dimension_data->width = 1;
-	dimension_data->ex = dimension_data->height = 1;
+        /* Called within the size function, so return a standard size */
+        dimension_data->em = dimension_data->width = 1;
+        dimension_data->ex = dimension_data->height = 1;
     }
 }
 
 /**
- * rsvg_handle_get_dimensions_sub
+ * rsvg_handle_get_dimensions_sub:
  * @handle: A #RsvgHandle
- * @dimension_data: A place to store the SVG's size
- * @id: An element's id within the SVG, or NULL to get the dimension of the whole SVG. 
- * For example, if you have a layer called "layer1" for that you want to get the dimension, 
- * pass "#layer1" as the id.
+ * @dimension_data: (out): A place to store the SVG's size
+ * @id: (nullable): An element's id within the SVG, or %NULL to get
+ *   the dimension of the whole SVG.  For example, if you have a layer
+ *   called "layer1" for that you want to get the dimension, pass
+ *   "#layer1" as the id.
  *
  * Get the size of a subelement of the SVG file. Do not call from within the size_func callback, because an infinite loop will occur.
  *
@@ -1314,7 +1371,6 @@ rsvg_handle_get_dimensions_sub (RsvgHandle * handle, RsvgDimensionData * dimensi
     cairo_t *cr;
     cairo_surface_t *target;
     RsvgDrawingCtx *draw;
-    RsvgCairoRender *render;
     RsvgNodeSvg *root = NULL;
     RsvgNode *sself = NULL;
     RsvgBbox bbox;
@@ -1327,81 +1383,73 @@ rsvg_handle_get_dimensions_sub (RsvgHandle * handle, RsvgDimensionData * dimensi
     memset (dimension_data, 0, sizeof (RsvgDimensionData));
 
     if (id && *id) {
-	sself = (RsvgNode *) rsvg_defs_lookup (handle->priv->defs, id);
+        sself = rsvg_defs_lookup (handle->priv->defs, id);
 
-	if (sself == (RsvgNode *) handle->priv->treebase)
-	    id = NULL;
+        if (sself == handle->priv->treebase)
+            id = NULL;
     }
     else
-	sself = (RsvgNode *) handle->priv->treebase;
+        sself = handle->priv->treebase;
 
     if (!sself && id)
-	return FALSE;
+        return FALSE;
 
     root = (RsvgNodeSvg *) handle->priv->treebase;
 
     if (!root)
-	return FALSE;
+        return FALSE;
 
-    bbox.x = bbox.y = 0;
-    bbox.w = bbox.h = 1;
+    bbox.rect.x = bbox.rect.y = 0;
+    bbox.rect.width = bbox.rect.height = 1;
 
     if (!id && (root->w.factor == 'p' || root->h.factor == 'p')
-	    && root->vbox.active && root->vbox.w > 0. && root->vbox.h > 0.)
-	handle_subelement = TRUE;
+            && !root->vbox.active)
+        handle_subelement = TRUE;
     else if (!id && root->w.length != -1 && root->h.length != -1)
-	handle_subelement = FALSE;
+        handle_subelement = FALSE;
 
     if (handle_subelement == TRUE) {
-	target = cairo_image_surface_create (CAIRO_FORMAT_RGB24,
-					 1, 1);
-	cr = cairo_create  (target);
+        target = cairo_image_surface_create (CAIRO_FORMAT_RGB24,
+                                             1, 1);
+        cr = cairo_create  (target);
 
-	draw = rsvg_cairo_new_drawing_ctx (cr, handle);
-    
-	if (!draw) {
-	    cairo_destroy (cr);
-	    cairo_surface_destroy (target);
-	    
-	    return FALSE;
-	}
+        draw = rsvg_cairo_new_drawing_ctx (cr, handle);
 
-	while (sself != NULL) {
-	    draw->drawsub_stack = g_slist_prepend (draw->drawsub_stack, sself);
-	    sself = sself->parent;
-	}
+        if (!draw) {
+            cairo_destroy (cr);
+            cairo_surface_destroy (target);
 
-	rsvg_state_push (draw);
-	cairo_save (cr);
+            return FALSE;
+        }
 
-	rsvg_node_draw ((RsvgNode *) handle->priv->treebase, draw, 0);
-	render = (RsvgCairoRender *) draw->render;
+        while (sself != NULL) {
+            draw->drawsub_stack = g_slist_prepend (draw->drawsub_stack, sself);
+            sself = sself->parent;
+        }
+
+        rsvg_state_push (draw);
+        cairo_save (cr);
 
-	bbox.x = render->bbox.x;
-	bbox.y = render->bbox.y;
-	bbox.w = render->bbox.w;
-	bbox.h = render->bbox.h;
+        rsvg_node_draw (handle->priv->treebase, draw, 0);
+        bbox = RSVG_CAIRO_RENDER (draw->render)->bbox;
 
-	cairo_restore (cr);
-	rsvg_state_pop (draw);
-	rsvg_drawing_ctx_free (draw);
-	cairo_destroy (cr);
-	cairo_surface_destroy (target);
+        cairo_restore (cr);
+        rsvg_state_pop (draw);
+        rsvg_drawing_ctx_free (draw);
+        cairo_destroy (cr);
+        cairo_surface_destroy (target);
 
-	dimension_data->width = (int) (_rsvg_css_hand_normalize_length_sub (&root->w, bbox.w, handle->priv->dpi_x,
-									    bbox.w + bbox.x * 2, 12) + 0.5);
-	dimension_data->height = (int) (_rsvg_css_hand_normalize_length_sub (&root->h, bbox.h, handle->priv->dpi_y, 
-									    bbox.h + bbox.y * 2,
-									    12) + 0.5);
+        dimension_data->width = bbox.rect.width;
+        dimension_data->height = bbox.rect.height;
     } else {
-	bbox.w = root->vbox.w; 
-	bbox.h = root->vbox.h; 
-
-	dimension_data->width = (int) (_rsvg_css_hand_normalize_length (&root->w, handle->priv->dpi_x,
-									bbox.w + bbox.x * 2, 12) + 0.5);
-	dimension_data->height = (int) (_rsvg_css_hand_normalize_length (&root->h, handle->priv->dpi_y, 
-									bbox.h + bbox.y * 2,
-									12) + 0.5);
+        bbox.rect.width = root->vbox.rect.width;
+        bbox.rect.height = root->vbox.rect.height;
+
+        dimension_data->width = (int) (_rsvg_css_hand_normalize_length (&root->w, handle->priv->dpi_x,
+                                       bbox.rect.width + bbox.rect.x * 2, 12) + 0.5);
+        dimension_data->height = (int) (_rsvg_css_hand_normalize_length (&root->h, handle->priv->dpi_y,
+                                         bbox.rect.height + bbox.rect.y * 2,
+                                         12) + 0.5);
     }
     
     dimension_data->em = dimension_data->width;
@@ -1415,12 +1463,12 @@ rsvg_handle_get_dimensions_sub (RsvgHandle * handle, RsvgDimensionData * dimensi
 }
 
 /**
- * rsvg_handle_get_position_sub
+ * rsvg_handle_get_position_sub:
  * @handle: A #RsvgHandle
- * @position_data: A place to store the SVG fragment's position.
+ * @position_data: (out): A place to store the SVG fragment's position.
  * @id: An element's id within the SVG.
  * For example, if you have a layer called "layer1" for that you want to get
- * the position, pass "#layer1" as the id.
+ * the position, pass "##layer1" as the id.
  *
  * Get the position of a subelement of the SVG file. Do not call from within
  * the size_func callback, because an infinite loop will occur.
@@ -1430,96 +1478,84 @@ rsvg_handle_get_dimensions_sub (RsvgHandle * handle, RsvgDimensionData * dimensi
 gboolean
 rsvg_handle_get_position_sub (RsvgHandle * handle, RsvgPositionData * position_data, const char *id)
 {
-	RsvgDrawingCtx		*draw;
-	RsvgNodeSvg			*root;
-	RsvgNode			*node;
-	RsvgBbox			 bbox;
-	RsvgDimensionData    dimension_data;
-	cairo_surface_t		*target = NULL;
-	cairo_t				*cr = NULL;
-	gboolean			 ret = FALSE;
-
-	g_return_val_if_fail (handle, FALSE);
-	g_return_val_if_fail (position_data, FALSE);
-
-	/* Short-cut when no id is given. */
-	if (NULL == id || '\0' == *id) {
-		position_data->x = 0;
-		position_data->y = 0;
-		return TRUE;
-	}
+    RsvgDrawingCtx		*draw;
+    RsvgNodeSvg			*root;
+    RsvgNode			*node;
+    RsvgBbox			 bbox;
+    RsvgDimensionData    dimension_data;
+    cairo_surface_t		*target = NULL;
+    cairo_t				*cr = NULL;
+    gboolean			 ret = FALSE;
 
-	memset (position_data, 0, sizeof (*position_data));
-	memset (&dimension_data, 0, sizeof (dimension_data));
-
-	node = (RsvgNode *) rsvg_defs_lookup (handle->priv->defs, id);
-	if (!node) {
-		return FALSE;
-	} else if (node == (RsvgNode *) handle->priv->treebase) {
-		/* Root node. */
-		position_data->x = 0;
-		position_data->y = 0;
-		return TRUE;
-	}
+    g_return_val_if_fail (handle, FALSE);
+    g_return_val_if_fail (position_data, FALSE);
 
-	root = (RsvgNodeSvg *) handle->priv->treebase;
-	if (!root)
-		return FALSE;
+    /* Short-cut when no id is given. */
+    if (NULL == id || '\0' == *id) {
+        position_data->x = 0;
+        position_data->y = 0;
+        return TRUE;
+    }
 
-	target = cairo_image_surface_create (CAIRO_FORMAT_RGB24, 1, 1);
-	cr = cairo_create  (target);
-	draw = rsvg_cairo_new_drawing_ctx (cr, handle);
-	if (!draw)
-	    goto bail;
+    memset (position_data, 0, sizeof (*position_data));
+    memset (&dimension_data, 0, sizeof (dimension_data));
 
-	while (node != NULL) {
-	    draw->drawsub_stack = g_slist_prepend (draw->drawsub_stack, node);
-	    node = node->parent;
-	}
+    node = rsvg_defs_lookup (handle->priv->defs, id);
+    if (!node) {
+        return FALSE;
+    } else if (node == handle->priv->treebase) {
+        /* Root node. */
+        position_data->x = 0;
+        position_data->y = 0;
+        return TRUE;
+    }
 
-	rsvg_state_push (draw);
-	cairo_save (cr);
+    root = (RsvgNodeSvg *) handle->priv->treebase;
+    if (!root)
+        return FALSE;
 
-	rsvg_node_draw ((RsvgNode *) handle->priv->treebase, draw, 0);
-	bbox.x = ((RsvgCairoRender *) draw->render)->bbox.x;
-	bbox.y = ((RsvgCairoRender *) draw->render)->bbox.y;
-	bbox.w = ((RsvgCairoRender *) draw->render)->bbox.w;
-	bbox.h = ((RsvgCairoRender *) draw->render)->bbox.h;
+    target = cairo_image_surface_create (CAIRO_FORMAT_RGB24, 1, 1);
+    cr = cairo_create  (target);
+    draw = rsvg_cairo_new_drawing_ctx (cr, handle);
+    if (!draw)
+        goto bail;
 
-	cairo_restore (cr);
-	rsvg_state_pop (draw);
-	rsvg_drawing_ctx_free (draw);
+    while (node != NULL) {
+        draw->drawsub_stack = g_slist_prepend (draw->drawsub_stack, node);
+        node = node->parent;
+    }
 
-	/* Calculate position.
-	 * TODO: figure out what "bbox.w + bbox.x * 2" is or means
-	 * (copied from rsvg_handle_get_dimensions_sub(). - robsta */
-	position_data->x = (int) (_rsvg_css_hand_normalize_length_sub (&root->x, bbox.x, handle->priv->dpi_x,
-									    bbox.w + bbox.x * 2, 12) + 0.5);
-	position_data->y = (int) (_rsvg_css_hand_normalize_length_sub (&root->y, bbox.y, handle->priv->dpi_y, 
-									    bbox.h + bbox.y * 2, 12) + 0.5);
+    rsvg_state_push (draw);
+    cairo_save (cr);
 
-	/* Also calculate dimension for the size callback, while re're at it. */
-	dimension_data.width = (int) (_rsvg_css_hand_normalize_length_sub (&root->w, bbox.w, handle->priv->dpi_x,
-									    bbox.w + bbox.x * 2, 12) + 0.5);
-	dimension_data.height = (int) (_rsvg_css_hand_normalize_length_sub (&root->h, bbox.h, handle->priv->dpi_y, 
-									    bbox.h + bbox.y * 2, 12) + 0.5);
+    rsvg_node_draw (handle->priv->treebase, draw, 0);
+    bbox = RSVG_CAIRO_RENDER (draw->render)->bbox;
 
-	dimension_data.em = dimension_data.width;
-	dimension_data.ex = dimension_data.height;
+    cairo_restore (cr);
+    rsvg_state_pop (draw);
+    rsvg_drawing_ctx_free (draw);
 
-	if (handle->priv->size_func)
-	    (*handle->priv->size_func) (&dimension_data.width, &dimension_data.height,
-	                                handle->priv->user_data);
+    position_data->x = bbox.rect.x;
+    position_data->y = bbox.rect.y;
+    dimension_data.width = bbox.rect.width;
+    dimension_data.height = bbox.rect.height;
 
-        ret = TRUE;
+    dimension_data.em = dimension_data.width;
+    dimension_data.ex = dimension_data.height;
+
+    if (handle->priv->size_func)
+        (*handle->priv->size_func) (&dimension_data.width, &dimension_data.height,
+                                    handle->priv->user_data);
+
+    ret = TRUE;
 
 bail:
-	if (cr)
-		cairo_destroy (cr);
-	if (target)
-		cairo_surface_destroy (target);
+    if (cr)
+        cairo_destroy (cr);
+    if (target)
+        cairo_surface_destroy (target);
 
-	return ret;
+    return ret;
 }
 
 /** 
@@ -1546,11 +1582,11 @@ rsvg_handle_has_sub (RsvgHandle * handle,
 }
 
 /** 
- * rsvg_set_default_dpi
+ * rsvg_set_default_dpi:
  * @dpi: Dots Per Inch (aka Pixels Per Inch)
  *
  * Sets the DPI for the all future outgoing pixbufs. Common values are
- * 75, 90, and 300 DPI. Passing a number <= 0 to #dpi will 
+ * 75, 90, and 300 DPI. Passing a number <= 0 to @dpi will
  * reset the DPI to whatever the default value happens to be.
  *
  * Since: 2.8
@@ -1562,12 +1598,12 @@ rsvg_set_default_dpi (double dpi)
 }
 
 /** 
- * rsvg_set_default_dpi_x_y
+ * rsvg_set_default_dpi_x_y:
  * @dpi_x: Dots Per Inch (aka Pixels Per Inch)
  * @dpi_y: Dots Per Inch (aka Pixels Per Inch)
  *
  * Sets the DPI for the all future outgoing pixbufs. Common values are
- * 75, 90, and 300 DPI. Passing a number <= 0 to #dpi will 
+ * 75, 90, and 300 DPI. Passing a number <= 0 to @dpi will
  * reset the DPI to whatever the default value happens to be.
  *
  * Since: 2.8
@@ -1587,12 +1623,12 @@ rsvg_set_default_dpi_x_y (double dpi_x, double dpi_y)
 }
 
 /**
- * rsvg_handle_set_dpi
+ * rsvg_handle_set_dpi:
  * @handle: An #RsvgHandle
  * @dpi: Dots Per Inch (aka Pixels Per Inch)
  *
  * Sets the DPI for the outgoing pixbuf. Common values are
- * 75, 90, and 300 DPI. Passing a number <= 0 to #dpi will 
+ * 75, 90, and 300 DPI. Passing a number <= 0 to @dpi will
  * reset the DPI to whatever the default value happens to be.
  *
  * Since: 2.8
@@ -1604,13 +1640,13 @@ rsvg_handle_set_dpi (RsvgHandle * handle, double dpi)
 }
 
 /**
- * rsvg_handle_set_dpi_x_y
+ * rsvg_handle_set_dpi_x_y:
  * @handle: An #RsvgHandle
  * @dpi_x: Dots Per Inch (aka Pixels Per Inch)
  * @dpi_y: Dots Per Inch (aka Pixels Per Inch)
  *
  * Sets the DPI for the outgoing pixbuf. Common values are
- * 75, 90, and 300 DPI. Passing a number <= 0 to #dpi_x or #dpi_y will 
+ * 75, 90, and 300 DPI. Passing a number <= 0 to #dpi_x or @dpi_y will
  * reset the DPI to whatever the default value happens to be.
  *
  * Since: 2.8
@@ -1634,7 +1670,7 @@ rsvg_handle_set_dpi_x_y (RsvgHandle * handle, double dpi_x, double dpi_y)
 /**
  * rsvg_handle_set_size_callback:
  * @handle: An #RsvgHandle
- * @size_func: A sizing function, or %NULL
+ * @size_func: (nullable): A sizing function, or %NULL
  * @user_data: User data to pass to @size_func, or %NULL
  * @user_data_destroy: Destroy function for @user_data, or %NULL
  *
@@ -1645,6 +1681,31 @@ rsvg_handle_set_dpi_x_y (RsvgHandle * handle, double dpi_x, double dpi_y)
  * arguments are set to -1.
  *
  * Deprecated: Set up a cairo matrix and use rsvg_handle_render_cairo() instead.
+ * You can call rsvg_handle_get_dimensions() to figure out the size of your SVG,
+ * and then scale it to the desired size via Cairo.  For example, the following
+ * code renders an SVG at a specified size, scaled proportionally from whatever
+ * original size it may have had:
+ *
+ * |[<!-- language="C" -->
+ * void
+ * render_scaled_proportionally (RsvgHandle *handle, cairo_t cr, int width, int height)
+ * {
+ *     RsvgDimensionData dimensions;
+ *     double x_factor, y_factor;
+ *     double scale_factor;
+ * 
+ *     rsvg_handle_get_dimensions (handle, &dimensions);
+ * 
+ *     x_factor = (double) width / dimensions.width;
+ *     y_factor = (double) height / dimensions.height;
+ * 
+ *     scale_factor = MIN (x_factor, y_factor);
+ * 
+ *     cairo_scale (cr, scale_factor, scale_factor);
+ * 
+ *     rsvg_handle_render_cairo (handle, cr);
+ * }
+ * ]|
  **/
 void
 rsvg_handle_set_size_callback (RsvgHandle * handle,
